{{progress=10}}
{{title='Evaluation'}}
{{icon="results"}}
{{goals = db(db.t_goals).select().first().as_dict()}}
<head>
    <link rel="stylesheet" type="text/css" href="{{=URL('static','css/resultsTable.css')}}">
    <link rel="stylesheet" type="text/css" href="{{=URL('static','css/nextButtonCss.css')}}">
    <script src="https://code.jquery.com/jquery-3.6.0.slim.js" integrity="sha256-HwWONEZrpuoh951cQD1ov2HUK5zA5DwJ1DNUXaM6FsY=" crossorigin="anonymous"></script>
    <script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/jspdf/1.5.3/jspdf.min.js"></script>
    <script type="text/javascript" src="https://html2canvas.hertzen.com/dist/html2canvas.js"></script>
{{extend 'header.html'}}
</head>
<body>
    <script>
        //Script to download tables as pdf
        function CreatePDFfromHTML() {
            var pdf = "";
            
            html2canvas($("#resultsTable")[0]).then(function (canvas) {
                var HTML_Width = $("#resultsTable").width();
                var HTML_Height = $("#resultsTable").height();
                var top_left_margin = 15;
                var PDF_Width = HTML_Width + (top_left_margin * 2);
                var PDF_Height = (PDF_Width * 1.5) + (top_left_margin * 2);
                var canvas_image_width = HTML_Width;
                var canvas_image_height = HTML_Height;
                var totalPDFPages = Math.ceil(HTML_Height / PDF_Height) - 1;
                
                var imgData = canvas.toDataURL("image/jpeg", 1.0);
                pdf = new jsPDF('p', 'pt', [PDF_Width, PDF_Height]);
                pdf.addImage(imgData, 'JPG', top_left_margin, top_left_margin, canvas_image_width, canvas_image_height);
                for (var i = 1; i <= totalPDFPages; i++) { 
                    pdf.addPage(PDF_Width, PDF_Height);
                    pdf.addImage(imgData, 'JPG', top_left_margin, -(PDF_Height*i)+(top_left_margin*4),canvas_image_width,canvas_image_height);
                }
            });
            html2canvas($("#economicresultsTable")[0]).then(function (canvas) {
                var HTML_Width = $("#economicresultsTable").width();
                var HTML_Height = $("#economicresultsTable").height();
                var top_left_margin = 15;
                var PDF_Width = HTML_Width + (top_left_margin * 2);
                var PDF_Height = (PDF_Width * 1.5) + (top_left_margin * 2);
                var canvas_image_width = HTML_Width;
                var canvas_image_height = HTML_Height;
                var totalPDFPages = Math.ceil(HTML_Height / PDF_Height) - 1;
                
                var imgData = canvas.toDataURL("image/jpeg", 1.0);
                pdf.addPage(PDF_Width, PDF_Height);
                pdf.addImage(imgData, 'JPG', top_left_margin, top_left_margin, canvas_image_width, canvas_image_height);
                for (var i = 1; i <= totalPDFPages; i++) { 
                    pdf.addPage(PDF_Width, PDF_Height);
                    pdf.addImage(imgData, 'JPG', top_left_margin, -(PDF_Height*i)+(top_left_margin*4),canvas_image_width,canvas_image_height);
                }
                pdf.save("Technical_KPIs.pdf");
            });
        }
    </script>
    <div id="main">
        <div id="resultsWrapper">
            <div id="tableTechnical">
                <table id="resultsTable">
                    <colgroup><col width="250px"><col width="300px"><col width="150px"></colgroup>
                    <tr class="headerRow"><th rowspan="1">Technical Goals</th><th rowspan="2" style="border-bottom:1px solid black;">KPI</th><th rowspan="2" style="border-bottom:1px solid black;">Delta</th></tr>
                    <tr><th class="hiddenrow" style="border-bottom:1px solid black;"><span>Irim</span></th></tr>
                    {{if goals['f_flex']:}}<tr class="dataRow"><td rowspan="2"><span class="icon-G-Goal-Criteria_Flexibility"> Flexibility</span></td>
                        <td class="subDataField">Product Flexibility (Max)</td>
                        <td class="subDataField">{{try:}}{{=round((kpi5G['f_product_flexibility']-kpiNo5G['f_product_flexibility'])/kpiNo5G['f_product_flexibility'],3)}} %{{except:}}0{{pass}}</td>
                    </tr>
                    <tr class="dataRowEnd"><td class="subDataField last">Setup Ratio (Min)</td>
                        <td class="subDataField last">{{try:}}{{=round((kpi5G['f_setup_ratio']-kpiNo5G['f_setup_ratio'])/kpiNo5G['f_setup_ratio']*100,3)}} % {{except:}}0{{pass}}</td>
                    </tr>{{pass}}
                    {{if goals['f_mob']:}}<tr class="dataRow"><td rowspan="2"><span class="icon-G-Goal-Criteria_Mobility"> Mobility</span></td>
                        <td class="subDataField">Application Handling Mobility (Max)</td>
                        <td class="subDataField">{{try:}}{{=round((kpi5G['f_application_handling_mobility']-kpiNo5G['f_application_handling_mobility'])/kpiNo5G['f_application_handling_mobility']*100,3)}} % {{except:}}0{{pass}}</td>
                    </tr>
                    <tr class="dataRowEnd"><td class="subDataField last">Space Productivity (Max)</td>
                        <td class="subDataField last">{{try:}}{{=round((kpi5G['f_space_productivity']-kpiNo5G['f_space_productivity'])/kpiNo5G['f_space_productivity']*100,3)}} % {{except:}}0{{pass}}</td>
                    </tr>{{pass}}
                    {{if goals['f_prod']:}}<tr class="dataRow"><td rowspan="3"><span class="icon-G-Goal-Criteria_Productivity"> Productivity</span></td>
                        <td class="subDataField">Effectiveness (Max)</td>
                        <td class="subDataField">{{try:}}{{=round((kpi5G['f_effectiveness']-kpiNo5G['f_effectiveness'])/kpiNo5G['f_effectiveness']*100,3)}} % {{except:}}0{{pass}}</td>
                    </tr>
                    <tr class="dataRow"><td class="subDataField">Throughput Ratio (Max)</td>
                        <td class="subDataField">{{try:}}{{=round((kpi5G['f_throughput_ratio']-kpiNo5G['f_throughput_ratio'])/kpiNo5G['f_throughput_ratio']*100,3)}} % {{except:}}0{{pass}}</td>
                    </tr>
                    <tr class="dataRowEnd"><td class="subDataField last">Worker Efficiency (Max)</td>
                        <td class="subDataField last">{{try:}}{{=round((kpi5G['f_worker_efficiency']-kpiNo5G['f_worker_efficiency'])/kpiNo5G['f_worker_efficiency']*100,3)}} % {{except:}}0{{pass}}</td>
                    </tr>{{pass}}
                    {{if goals['f_qual']:}}<tr class="dataRow"><td rowspan="4"><span class="icon-G-Goal-Criteria_Quality"> Quality</span></td>
                        <td class="subDataField">First Pass Yield (Max)</td>
                        <td class="subDataField">{{try:}}{{=round((kpi5G['f_first_pass_yield']-kpiNo5G['f_first_pass_yield'])/kpiNo5G['f_first_pass_yield']*100,3)}} % {{except:}}0{{pass}}</td>
                    </tr>
                    <tr class="dataRow"><td class="subDataField">Quality Ratio (Max)</td>
                        <td class="subDataField">{{try:}}{{=round((kpi5G['f_quality_ratio']-kpiNo5G['f_quality_ratio'])/kpiNo5G['f_quality_ratio']*100,3)}} % {{except:}}0{{pass}}</td>
                    </tr>
                    <tr class="dataRow"><td class="subDataField">Rework Ratio (Min)</td>
                        <td class="subDataField">{{try:}}{{=round((kpi5G['f_rework_ratio']-kpiNo5G['f_rework_ratio'])/kpiNo5G['f_rework_ratio']*100,3)}} % {{except:}}0{{pass}}</td>
                    </tr>
                    <tr class="dataRowEnd"><td class="subDataField last">Scrap Ratio (Min)</td>
                        <td class="subDataField last">{{try:}}{{=round((kpi5G['f_scrap_ratio']-kpiNo5G['f_scrap_ratio'])/kpiNo5G['f_scrap_ratio']*100,3)}} % {{except:}}0{{pass}}</td>
                    </tr>{{pass}}
                    {{if goals['f_safe']:}}<tr class="dataRow"><td rowspan="3"><span class="icon-G-Goal-Criteria_Safety"> Safety</span></td>
                        <td class="subDataField">Accident Ratio (Min)</td>
                        <td class="subDataField">{{try:}}{{=round((kpi5G['f_accident_ratio']-kpiNo5G['f_accident_ratio'])/kpiNo5G['f_accident_ratio']*100,3)}} % {{except:}}0{{pass}}</td>
                    </tr>
                    <tr class="dataRow"><td class="subDataField">Mean Time Between Failures Ratio (Max)</td>
                        <td class="subDataField">{{try:}}{{=round((kpi5G['f_mean_time_between_failures']-kpiNo5G['f_mean_time_between_failures'])/kpiNo5G['f_mean_time_between_failures']*100,3)}} % {{except:}}0{{pass}}</td>
                    </tr>
                    <tr class="dataRowEnd"><td class="subDataField last">Mean Time to Repair Ratio (Min)</td>
                        <td class="subDataField last">{{try:}}{{=round((kpi5G['f_mean_time_to_repair']-kpiNo5G['f_mean_time_to_repair'])/kpiNo5G['f_mean_time_to_repair']*100,3)}} % {{except:}}0{{pass}}</td>
                    </tr>{{pass}}
                    {{if goals['f_sus']:}}<tr class="dataRow"><td rowspan="4"><span class="icon-G-Goal-Criteria_Sustainability"> Sustainability</span></td>
                        <td class="subDataField">Compressed Air Consumption Ratio (Min)</td>
                        <td class="subDataField">{{try:}}{{=round((kpi5G['f_compressed_air_consumption_ratio']-kpiNo5G['f_compressed_air_consumption_ratio'])/kpiNo5G['f_compressed_air_consumption_ratio']*100,3)}} % {{except:}}0{{pass}}</td>
                    </tr>
                    <tr class="dataRow"><td class="subDataField">Electric Power Consumption Ratio (Min)</td>
                        <td class="subDataField">{{try:}}{{=round((kpi5G['f_electric_power_consumption_ratio']-kpiNo5G['f_electric_power_consumption_ratio'])/kpiNo5G['f_electric_power_consumption_ratio']*100,3)}} % {{except:}}0{{pass}}</td>
                    </tr>
                    <tr class="dataRow"><td class="subDataField">Gas Consumption Ratio (Min)</td>
                        <td class="subDataField">{{try:}}{{=round((kpi5G['f_gas_consumption_ratio']-kpiNo5G['f_gas_consumption_ratio'])/kpiNo5G['f_gas_consumption_ratio']*100,3)}} % {{except:}}0{{pass}}</td>
                    </tr>
                    <tr class="dataRowEnd"><td class="subDataField last">Water Consumption Ratio (Min)</td>
                        <td class="subDataField last">{{try:}}{{=round((kpi5G['f_water_consumption_ratio']-kpiNo5G['f_water_consumption_ratio'])/kpiNo5G['f_water_consumption_ratio']*100,3)}} % {{except:}}0{{pass}}</td>
                    </tr>{{pass}}
                    {{if goals['f_util']:}}<tr class="dataRow"><td rowspan="4"><span class="icon-G-Goal-Criteria_Utilization"> Utilization</span></td>
                    <td class="subDataField">Allocation Efficiency (Max)</td>
                        <td class="subDataField">{{try:}}{{=round((kpi5G['f_allocation_efficiency']-kpiNo5G['f_allocation_efficiency'])/kpiNo5G['f_allocation_efficiency']*100,3)}} % {{except:}}0{{pass}}</td>
                    </tr>
                    <tr class="dataRow"><td class="subDataField">Availability (Max)</td>
                        <td class="subDataField">{{try:}}{{=round((kpi5G['f_availability']-kpiNo5G['f_availability'])/kpiNo5G['f_availability']*100,3)}} % {{except:}}0{{pass}}</td>
                    </tr>
                    <tr class="dataRow"><td class="subDataField">Technical Efficiency (Max)</td>
                        <td class="subDataField">{{try:}}{{=round((kpi5G['f_technical_efficiency']-kpiNo5G['f_technical_efficiency'])/kpiNo5G['f_technical_efficiency']*100,3)}} % {{except:}}0{{pass}}</td>
                    </tr>
                    <tr class="dataRowEnd"><td class="subDataField last">Utilization Efficiency (Max)</td>
                        <td class="subDataField last">{{try:}}{{=round((kpi5G['f_utilization_efficiency']-kpiNo5G['f_utilization_efficiency'])/kpiNo5G['f_utilization_efficiency']*100,3)}} % {{except:}}0{{pass}}</td>
                    </tr>{{pass}}
                </table>
            </div>
            <div id="tableEconomic">
                <table id="economicresultsTable">
                    <colgroup><col width="250px"><col width="150px"><col width="150px" span="2"></colgroup>
                    <tr class="headerRow"><th rowspan="1">Economic Figures</th><th style= "border-bottom:1px solid black;">Without 5G</th><th colspan="2" style="border-left: 1px solid black; border-bottom:1px solid black;">With 5G</th></tr>
                    <tr class="subheaderRow"><th></th><th>Value</th><th style="border-left: 1px solid black;">Value</th><th>Delta</th></tr>
                    {{if goals['f_pb']:}}<tr class="dataRowEnd"><td><span class="icon-Economic-Goals_Payback-Period"> Payback Period (Years)</span></td><td>{{=round(payback[0],3)}}</td><td>{{try:}}{{=round(payback[1],3)}}{{except:}}{{=XML(payback[1])}}{{pass}}</td><td>{{try:}}{{=round((invest[1]-invest[0])/(cashflow[1]-cashflow[0]),3)}} {{except:}}0{{pass}}</td></tr>{{pass}}
                    {{if goals['f_opexp']:}}<tr class="dataRowEnd"><td><span class="icon-Economic-Goals_Opex-per-Product"> OPEX/Product (€)</span></td><td>{{=round(opexperP[0],3)}}</td><td>{{=round(opexperP[1],3)}}</td><td>{{try:}}{{=round((opexperP[1]-opexperP[0]),3)}} {{except:}}0{{pass}}</td></tr>{{pass}}
                    {{if goals['f_npv']:}}<tr class="dataRowEnd"><td><span class="icon-growth"> NPV (Mio. €)</span></td><td>{{=round(npv[0]/1000000,3)}}</td><td>{{=round(npv[1]/1000000,3)}}</td><td>{{try:}}{{=round((float(request.vars.npv_delta)/1000000),3)}} {{except:}}0{{pass}}</td></tr>{{pass}}
                    {{if goals['f_roi']:}}<tr class="dataRowEnd"><td><span class="icon-return-on-investment"> RoI (%)</span></td><td>{{=round(roi[0],3)}}</td><td>{{=round(roi[1],3)}}</td><td>{{try:}}{{=round((profit[1]-profit[0])/(invest[1]-invest[0]),3)}} % {{except:}}0{{pass}}</td></tr>{{pass}}
                </table>
            </div>
        </div>
        <div class="backDiv">
            <div id="backToMain"><a href="{{=backUrl}}" class="button">Back</a></div>
            <div id="downloadButton"><button onclick="CreatePDFfromHTML()" class="button">Download Table</button></div>
            <div id = "nextButton">
                <a class="button" href='{{=URL("ct_start","mainScreen")}}'>
                  To the Overview
                </a>
            </div>
        </div>
    </div>
</body>
